<?php
/**
 * @project Astra.CMS
 * @link http://a-cms.ru/
 * @copyright 2011 "Астра Вебтехнологии"
 * @author Vitaly Hohlov <admin@a-cms.ru>
 * @package Blocks
 */
/**************************************************************************/

/**
 * Блок "Магазин Lite: Фильтры".
 *
 * <a href="http://wiki.a-cms.ru/blocks/shoplite_filters">Руководство</a>.
 */

class shoplite_filters_Block extends A_Block
{
/**
 * Специальная обработка параметров блока.
 *
 * @return array
 */

  function prepareParams()
  {
	$params=array();
    $params['idsec']=(integer)$_REQUEST['b_idsec'];
    $params['template']=$_REQUEST['b_template'];
    $params['filters']=array();
    if($section=getSectionbyId($params['idsec']))
	{ $fields=array('name','idcat','price','favorite','new');
	  $fields=array_merge($fields,array_keys(getFields($section)));
	  foreach($fields as $i=>$field)
	  $params['filters'][$field]=array(
	  'caption'=>!empty($_REQUEST['b_caption_'.$field])?strip_tags(trim($_REQUEST['b_caption_'.$field])):'',
	  'checked'=>!empty($_REQUEST['b_fields'])&&in_array($field,$_REQUEST['b_fields']),
	  'sort'=>isset($_REQUEST['b_sort_'.$field])?(integer)$_REQUEST['b_sort_'.$field]:$i+1);
    }
    return $params;
  }

  function getCategories(&$values,$id,$owner,$idcats)
  {
    A::$DB->query("SELECT * FROM ".$this->section."_categories WHERE idker=$id AND active='Y' ORDER BY sort");
	if(!empty($owner))
	$owner.="&nbsp;&raquo;&nbsp;";
	while($row=A::$DB->fetchRow())
    { if(in_array($row['id'],$idcats))
	  $values[$row['id']]=$owner.$row['name'];
      $this->getCategories($values,$row['id'],$owner.$row['name'],$idcats);
	}
	A::$DB->free();
  }

/**
 * Формирование данных доступных в шаблоне.
 */

  function createData()
  {
	$form=array();

	if(!empty($_GET['idcat']))
	{ if(is_array($_GET['idcat']))
	  { $checked=array();
		foreach($_GET['idcat'] as $value)
		$checked[]=(integer)$value;
		$idcat=$checked;
	  }
	  else
	  { if(SECTION==$this->section)
	    $idcat=!empty($_GET['idcat'])?(integer)$_GET['idcat']:A::$MAINFRAME->idcat;
	    else
	    $idcat=!empty($_GET['idcat'])?(integer)$_GET['idcat']:0;
	  }
	}
	else
	$idcat=SECTION==$this->section?A::$MAINFRAME->idcat:0;

	$categories=array();
	if($idcats=A::$DB->getCol("SELECT DISTINCT idcat FROM {$this->section}_catalog WHERE active='Y'"))
	$this->getCategories($categories,0,"",array_unique(array_merge($idcats,is_array($idcat)?$idcat:array($idcat))));

    $form['idcat']=array(
	'field'=>'idcat',
	'type'=>'select',
	'caption'=>'Категория',
	'options'=>$categories,
	'value'=>$idcat);

	$lists=getLists();

	$fields=array(
	'name'=>'string',
	'content'=>'string',
	'tags'=>'string',
	'art'=>'string',
	'price'=>'int',
	'favorite'=>'bool',
	'new'=>'bool');

	$captions=array(
	'name'=>'Название',
	'content'=>'Описание',
	'tags'=>'Метки',
	'art'=>'Артикул',
	'price'=>'Цена',
	'favorite'=>'Спецпредложение',
	'new'=>'Новинка');

	if(!empty($_GET['price_min']))
	$_GET['price_min']=!empty($_REQUEST['price_min'])?$_REQUEST['price_min']:$_GET['price_min'];
	if(!empty($_GET['price_max']))
	$_GET['price_max']=!empty($_REQUEST['price_max'])?$_REQUEST['price_max']:$_GET['price_max'];

	$vars=array();
	foreach($fields as $field=>$type)
    $vars[]=array('field'=>$field,'caption'=>$captions[$field],'type'=>$type);

	$_fields=function_exists('cfields_getfields')?cfields_getfields($idcat,$this->section):null;

	A::$DB->query("SELECT * FROM ".getDomain($this->section)."_fields WHERE item='{$this->section}' ORDER BY sort");
    while($row=A::$DB->fetchRow())
    if(is_null($_fields) || isset($_fields[$row['field']]))
	{ $row['caption']=$row['name_'.A::$LANG];
	  $vars[]=$row;
    }
	A::$DB->free();

	foreach($vars as $row)
    { switch($row['type'])
	  { case 'string':
	    case 'text':
	      $form[$row['field']]=array('value'=>!empty($_GET[$row['field']])?htmlspecialchars($_GET[$row['field']]):'');
	      break;
	    case 'select':
		  $filter=array("active='Y'");
		  if($idcat)
		  { if(is_array($idcat))
		    { $idcats=$idcat;
		      foreach($idcat as $_idcat)
	          getTreeSubItems("{$this->section}_categories",$_idcat,$idcats);
		    }
		    else
		    { $idcats=array($idcat);
	          getTreeSubItems("{$this->section}_categories",$idcat,$idcats);
			}
			$filter[]="idcat IN (".implode(",",$idcats).")";
		  }
		  $ids=A::$DB->getCol("SELECT DISTINCT `{$row['field']}` FROM {$this->section}_catalog WHERE ".implode(" AND ",$filter));
		  $options=loadList($row['property']);
	      foreach($options as $id=>$value)
	      if(!in_array($id,$ids))
	      unset($options[$id]);
		  elseif(is_array($value))
	      $options[$id]=$value['name'];
		  if(!empty($_GET[$row['field']]))
		  { if(is_array($_GET[$row['field']]))
		    { $checked=array();
		      foreach($_GET[$row['field']] as $value)
		      $checked[]=(integer)$value;
		      $value=$checked;
		    }
			else
			$value=!empty($_GET[$row['field']])?(integer)$_GET[$row['field']]:0;
		  }
		  else
		  $value=0;
		  $form[$row['field']]=array('options'=>$options,'value'=>$value);
	      break;
	    case 'mselect':
		  $filter=array("active='Y'");
		  if($idcat)
		  { if(is_array($idcat))
		    { $idcats=$idcat;
		      foreach($idcat as $_idcat)
	          getTreeSubItems("{$this->section}_categories",$_idcat,$idcats);
		    }
		    else
		    { $idcats=array($idcat);
	          getTreeSubItems("{$this->section}_categories",$idcat,$idcats);
			}
			$filter[]="idcat IN (".implode(",",$idcats).")";
		  }
	      $values=A::$DB->getCol("SELECT DISTINCT `{$row['field']}` FROM {$this->section}_catalog WHERE ".implode(" AND ",$filter));
	      $values=array_unique(explode(',',implode(',',$values)));
	      foreach($values as $i=>$id)
	      $values[$i]=(integer)$id;
		  $options=loadList($row['property']);
		  foreach($options as $id=>$value)
	      if(!in_array($id,$values))
	      unset($options[$id]);
	      elseif(is_array($value))
	      $options[$id]=$value['name'];
		  if(!empty($_GET[$row['field']]))
		  { if(is_array($_GET[$row['field']]))
		    { $checked=array();
		      foreach($_GET[$row['field']] as $value)
		      $checked[]=(integer)$value;
		      $value=$checked;
		    }
			else
			$value=!empty($_GET[$row['field']])?(integer)$_GET[$row['field']]:0;
		  }
		  else
		  $value=0;

		  $form[$row['field']]=array('options'=>$options,'value'=>$value);
          break;
        case 'int':
		  if(isset($lists[$row['field']]))
		  { $options=loadList($row['field']);
		    foreach($options as $id=>$name)
		    if(is_array($name) && !empty($name['name']))
		    $options[$id]=$name['name'];
            $form[$row['field']]=array('options'=>$options,'value'=>!empty($_GET[$row['field']])?(integer)$_GET[$row['field']]:0);
          }
          else
          { $form[$row['field'].'_min']=array('value'=>!empty($_GET[$row['field'].'_min'])?(integer)$_GET[$row['field'].'_min']:'');
            $form[$row['field'].'_max']=array('value'=>!empty($_GET[$row['field'].'_max'])?(integer)$_GET[$row['field'].'_max']:'');
            $form[$row['field']]=array(
			'value'=>!empty($_GET[$row['field']])?(integer)$_GET[$row['field']]:'',
			'min'=>$form[$row['field'].'_min'],
			'max'=>$form[$row['field'].'_max']);
          }
          break;
        case 'float':
	      if(isset($lists[$row['field']]))
		  { $options=array();
		    $options=loadList($row['field']);
		    foreach($options as $id=>$name)
		    if(is_array($name) && !empty($name['name']))
		    $options[$id]=$name['name'];
            $form[$row['field']]=array('options'=>$options,'value'=>!empty($_GET[$row['field']])?(float)$_GET[$row['field']]:0);
          }
          else
          { $form[$row['field'].'_min']=array('value'=>!empty($_GET[$row['field'].'_min'])?(float)$_GET[$row['field'].'_min']:'');
            $form[$row['field'].'_max']=array('value'=>!empty($_GET[$row['field'].'_max'])?(float)$_GET[$row['field'].'_max']:'');
            $form[$row['field']]=array(
			'value'=>!empty($_GET[$row['field']])?(float)$_GET[$row['field']]:'',
			'min'=>$form[$row['field'].'_min'],
			'max'=>$form[$row['field'].'_max']);
          }
          break;
       case 'bool':
	      $form[$row['field']]=array('value'=>!empty($_GET[$row['field']])?'Y':'N');
	      break;
      }
      if(isset($form[$row['field']]))
      { $form[$row['field']]['field']=$row['field'];
        $form[$row['field']]['type']=$row['type'];
	    $form[$row['field']]['caption']=$row['caption'];
	  }
    }

	$this->Assign('form',$form);

	$filters=array();
	$_filters=!empty($this->params['filters'])?$this->params['filters']:array();
	foreach($_filters as $field=>$_filter)
	if(isset($form[$field]) && !empty($_filter['checked']))
	{ $form[$field]['caption']=$_filter['caption'];
	  $form[$field]['sort']=(integer)$_filter['sort'];
	  $filters[]=$form[$field];
	}
	$filters=array_multisort_key($filters,'sort');
	$this->Assign('filters',$filters);
  }
}